# Step-by-Step Guide

It's always nice to see new users onboarding into the Testnet Oro.

This will guide you through the process of running your own full node, then [becoming a validator](https://docs.kiiglobal.io/docs/validate-the-network/run-a-validator-full-node/step-by-step-guide/becoming-a-validator) and finally running[ the price feeder](https://docs.kiiglobal.io/docs/validate-the-network/run-a-validator-full-node/running-the-price-feeder)

## Install

`kiichaind` is the command-line interface (CLI) for interacting with the Kiichain blockchain. This section covers the installation of the necessary binaries to run a Kiichain node.

### Requirements

* **Golang version:** `v1.23.x`
* **Build tools:** `build-essential` package (Linux)

### Binary installation

To install Kiichain, download the pre-built binaries:

```bash
git clone https://github.com/KiiChain/kiichain.git
cd kiichain
make install
```

Verify the installation by checking the version of kiichaind:

```bash
kiichaind version
```

## Joining the Testnet

To join the Testnet Oro, you must have the daemon `kiichaind` installed in your machine.

### Recommended configuration

For optimal performance, we recommend:

* 4 vCPU x86\_64
* 8 GB RAM
* 1 TB NVME SSD

### Quick bootstrap

The easiest way to prepare a node is by using our provided scripts.

{% hint style="info" %}
These scripts are designed for systems running **Ubuntu 20.04** or **Ubuntu 22.04**. Ensure your operating system matches this requirement before proceeding.
{% endhint %}

* **Join Testnet Oro Script**: Use this script to bootstrap a full node quickly.

```bash
curl -O https://raw.githubusercontent.com/KiiChain/testnets/refs/heads/main/testnet_oro/join_oro.sh
chmod +x join_oro.sh
./join_oro.sh
```

* **Join Testnet with Cosmosvisor Script**: Use this script to set up a full node with Cosmosvisor for automated upgrades

```bash
curl -O https://raw.githubusercontent.com/KiiChain/testnets/refs/heads/main/testnet_oro/join_oro_cv.sh
chmod +x join_oro_cv.sh
./join_oro_cv.sh
```

### Running your node

Prepare your system by backing up and removing old configurations:

```bash
# Backup old configuration
cp -r $HOME/.kiichain $HOME/.kiichain-bk
# Clean any old configuration
rm -r $HOME/.kiichain
```

Connect to the testnet with the following commands:

```bash
# Variables used during the configuration
PERSISTENT_PEERS="5b6aa55124c0fd28e47d7da091a69973964a9fe1@uno.sentry.testnet.v3.kiivalidator.com:26656,5e6b283c8879e8d1b0866bda20949f9886aff967@dos.sentry.testnet.v3.kiivalidator.com:26656"
CHAIN_ID="oro_1336-1"
NODE_HOME=~/.kiichain
NODE_MONIKER=testnet_oro
GENESIS_URL=https://raw.githubusercontent.com/KiiChain/testnets/refs/heads/main/testnet_oro/genesis.json
MINIMUM_GAS_PRICES="1000000000akii"

# Initialize the chain
kiichaind init $NODE_MONIKER --chain-id $CHAIN_ID --home $NODE_HOME

# Set the persistent-peers
sed -i -e "/persistent-peers =/ s^= .*^= \"$PERSISTENT_PEERS\"^" $NODE_HOME/config/config.toml
# Set the min gas price
sed -i -e "/minimum-gas-prices =/ s^= .*^= \"$MINIMUM_GAS_PRICES\"^" $NODE_HOME/config/app.toml

# Set the genesis
wget $GENESIS_URL -O genesis.json
mv genesis.json $NODE_HOME/config/genesis.json

# Start the chain
kiichaind start --home $NODE_HOME
```

**(Optional but recommended)**: Before running the chain you can also check the SHA256:

```bash
sha256sum $NODE_HOME/config/genesis.json
```

The expected SHA256 checksum is: `2805ae1752dc8c3435afd6bdceea929b3bbd2883606f3f3589f4d62c99156d2d`

{% hint style="warning" %}
This configuration runs a full node. For validators, update the configuration accordingly!
{% endhint %}

### Cosmosvisor

Cosmosvisor is a process manager for handling chain upgrades. It enables low maintenance and automatic updates for nodes.

* If an upgrade is scheduled, cosmosvisor has the capability of automatically downloading binaries and restarting any Kiichain processes
* This gives the node low maintenance and auto updates capabilities

A version of our node bootstrapper can install cosmosvisor for you:

```
curl -O https://raw.githubusercontent.com/KiiChain/testnets/refs/heads/main/testnet_oro/join_oro_cv.sh
chmod +x join_oro_cv.sh
./join_oro_cv.sh
```

More information about cosmovision can be found at [Cosmosvisor Quick Start](https://docs.cosmos.network/v0.45/run-node/cosmovisor.html).

#### Preparing cosmosvisor upgrade

First, you need to compile new binaries:

* A new Kiichaind binary must be compiled with the target OS in mind
* Ideally, you should compile all binaries on it’s own machines
* **The build must be done on top of the upgrade tag (E.g. v1.0.1, v2.0.0)**
* Check the section [Binary Installation](#binary-installation) on how to do it

Make sure that the binary has the correct version with:

```
kiichaind version
```

To add a new upgrade you must run the following command on Cosmovisor:

```
cosmovisor add-upgrade <upgrade-name> <path-to-binary>
```

Where:

* `<upgrade-name>` is the on-chain upgrade name
* `<path-to-binary>` is the full path for the binary

Example:

```
cosmovisor add-upgrade 1.3.0 /home/ubuntu/kiichain/build/kiichaind
```

### Configure state sync

State sync significantly reduces the time required to synchronize a node by downloading and verifying state data from trusted peers rather than replaying every historical block. This is particularly beneficial for nodes joining the network late or recovering from a significant downtime.

Follow these steps to configure state sync for your Kiichain node:

1. **Set Trust Height Delta and Fetch Block Information**

Define a height delta and retrieve the latest block height and block hash from the primary RPC endpoint.

```shellscript
# Configure state-sync
TRUST_HEIGHT_DELTA=500
LATEST_HEIGHT=$(curl -s https://rpc.uno.sentry.testnet.v3.kiivalidator.com/block | jq -r ".block.header.height")
if [[ "$LATEST_HEIGHT" -gt "$TRUST_HEIGHT_DELTA" ]]; then
SYNC_BLOCK_HEIGHT=$(($LATEST_HEIGHT - $TRUST_HEIGHT_DELTA))
else
SYNC_BLOCK_HEIGHT=$LATEST_HEIGHT
fi

# Get the sync block hash
SYNC_BLOCK_HASH=$(curl -s "https://rpc.uno.sentry.testnet.v3.kiivalidator.com/block?height=$SYNC_BLOCK_HEIGHT" | jq -r ".block_id.hash")
```

2. Enable State Sync in Configuration

Modify the `config.toml` file to enable state sync and set the required parameters.

```bash
sed -i.bak -e "s|^enable *=.*|enable = true|" $NODE_HOME/config/config.toml
sed -i.bak -e "s|^rpc_servers *=.*|rpc_servers = \"$PRIMARY_ENDPOINT,$SECONDARY_ENDPOINT\"|" $NODE_HOME/config/config.toml
sed -i.bak -e "s|^trust_height *=.*|trust_height = $SYNC_BLOCK_HEIGHT|" $NODE_HOME/config/config.toml
sed -i.bak -e "s|^trust_hash *=.*|trust_hash = \"$SYNC_BLOCK_HASH\"|" $NODE_HOME/config/config.toml
```

### Turning your node into an archival node

Newly created nodes have the pruning option configured as default. If you desire to turn your node into an archival node, the following flag must be changed:

1. Go to `$NODE_HOME/config/app.toml`and update the following flag:

```
pruning = "nothing"
```

Other options available as default for pruning are:

* `default`: Keep the recent 362880 blocks and prune is triggered every 10 blocks
* `nothing`: all historic states will be saved, and nothing will be deleted (i.e. archiving node)
* `everything`: all saved states will be deleted, storing only the recent 2 blocks; pruning at every block
* `custom`: allow pruning options to be manually specified through 'pruning-keep-recent' and 'pruning-interval'

### Node Architecture for Validators

Further instructions on how to build a great node architecture can be found on:

* [Playbook For Cosmos Validators: Node Architecture Choices](https://medium.com/@kidinamoto/tech-choices-for-cosmos-validators-27c7242061ea)

## References

* [Running a Validator](https://hub.cosmos.network/main/validators/validator-setup.html)
* [Playbook For Cosmos Validators: Node Architecture Choices](https://medium.com/@kidinamoto/tech-choices-for-cosmos-validators-27c7242061ea)
* [Cosmosvisor Quick Start](https://docs.cosmos.network/v0.45/run-node/cosmovisor.html)
* [Join Testnet Oro](https://raw.githubusercontent.com/KiiChain/testnets/refs/heads/main/testnet_oro/join_oro.sh)
* [Join Testnet Oro CV](https://raw.githubusercontent.com/KiiChain/testnets/refs/heads/main/testnet_oro/join_oro_cv.sh)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.kiiglobal.io/docs/validate-the-network/run-a-validator-full-node/step-by-step-guide.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
